#include <iostream.h>
#include <stdlib.h>

#include "bootstrap.h"
#include "fisher.h"

//////////////////////////////////////////////////////////////////////////
// bootstrap with replacement
void BootRep(int *ind, int num)
{
	int i;
	for (i = 0; i < num; i++)
	{
		ind[i] = int(rand() / (RAND_MAX + 1.0) * num);
	}
}

//////////////////////////////////////////////////////////////////////////
// bootstrap without replacement, this is permutation
void BootNoRep(int *ind, int num)
{
	int i, j;

	// initialization
	for (i = 0; i < num; i++)
	{
		ind[i] = i;
	}

	int *iRand = new int[num];
	for (i = 0; i < num; i++)
	{
		iRand[i] = rand();
	}

	// babble sort
	for (i = 0; i < num-1; i++)
	{
		for (j = i+1; j < num; j++)
		{
			if (iRand[j] < iRand[i])
			{
				int temp;
				temp = iRand[j];
				iRand[j] = iRand[i];
				iRand[i] = temp;
				temp = ind[i];
				ind[i] = ind[j];
				ind[j] = temp;
			}
		}
	}
	delete[] iRand;
}

//////////////////////////////////////////////////////////////////////////
// the original sequence
void BootOri(int *ind, int num)
{
	int i;
	for (i = 0; i < num; i++)
	{
		ind[i] = i;
	}
}

//////////////////////////////////////////////////////////////////////////
// all kinds of bootstrap
void Bootstrap(int *ind, int num, int type)
{
	switch (type)
	{
		case BOOT_REP:
			{
				BootRep(ind, num);
				break;
			}
		case BOOT_NO_REP:
			{
				BootNoRep(ind, num);
				break;
			}
		default:	BootOri(ind, num);
	}

	int i;
	if (DEBUG != 2)
	{
		cout << "Bootstrap indices:  ";
		for (i = 0; i < num; i++)
		{
			cout << ind[i] << ' ';
		}
		cout << endl;
	}
}
