#include "fisher.h"

#if !defined MIXLIKTOOL_H
#define MIXLIKTOOL_H

int MixAverWholeRegRate(RateSearch& rs, Loci& lc, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);
void MixIniHotReg(HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, Loci& lc, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);
int MixMaxBkRate(HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);
void MixHot(RateSearch& rs, Loci& lc, DataLikMatrix& lm, LikTable& lt, WinWeight& ww, HotReg& hr, OptSr& os, FileNames& fn);
void EdgeWt(WinWeight& ww);

void MixInterBkRate(NewHot& nh, HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, DataLikMatrix& lm, LikTable& lt, OptSr& os);
void MixInterHotRate(NewHot& nh, HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, DataLikMatrix& lm, LikTable& lt, OptSr& os);
void AddOneHot(NewHot& nh, HotReg& temphr, GridRate& gr, SNPRate& sr, RateSearch& rs, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);
int MixMaxHotRate(Inter& hot, HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);

void MixSetBkTags(HotReg& hr, GridRate& gr, SNPRate& sr, RateSearch& rs, Loci& lc, DataLikMatrix& lm, LikTable& lt, OptSr& os, WinWeight& ww);

void EdgeCor(NewHot& nh, GridRate& gr, SNPRate& sr, WinWeight& ww);

int HotAvailable(Inter gint, HotReg& hr, GridRate& gr, SNPRate& sr);
void OutdLikMatrix(HotReg& hr, NewHot* nHot, WinWeight& ww);
int MaxdLikInd(HotReg& hr, NewHot* nHot, WinWeight& ww);
void UpdateHr(HotReg& hr, NewHot& nh, int iter);
void OutHr(HotReg& hr);
int GridBkBlock(Inter* sint, GridRate& gr, HotReg& hr, SNPRate& sr);

int LocGridSNP(int gNum, Loci& lc, GridRate& gr);
void IniPossiHot(NewHot *nHot, Loci& lc, WinWeight& ww, GridRate& gr, OptSr& os);
void CopyNewHot(NewHot& nnh, NewHot& nh, RateSearch& rs);


#endif
